// Blynk constants
#define BLYNK_TEMPLATE_ID "TMPL6LcfYiKbT"
#define BLYNK_TEMPLATE_NAME "Near TV Device"
#define BLYNK_AUTH_TOKEN "4foBfVA6r8TO6BClT_iBrnANcVhChX33"
#define BLYNK_PRINT SerialUSB

#include <ESP8266_Lib.h>
#include <BlynkSimpleShieldEsp8266.h>
#include <Adafruit_CircuitPlayground.h>

// Wifi setup constants
char ssid[] = "HPNA3-163";
char pass[] = "0051755081";
#define EspSerial Serial1
#define ESP8266_BAUD 115200
ESP8266 wifi(&EspSerial);

// Timer for the sound level
BlynkTimer timer;

// Setup code to turn off the samsung tv:
#define MY_PROTOCOL NECX
#define MY_BITS 32
#define MY_POWER 0xE0E040BF

// SOUND THRESHOLDS
#define SOUND_THRESHOLD_ON (72.0)
#define SOUND_THRESHOLD_OFF (63.0)

int isTVOn = 0; // This is a global stating whether the tv is on or not

void setup()
{
    // Debug console
    SerialUSB.begin(115200);
    CircuitPlayground.begin();

    // Set ESP8266 baud rate
    EspSerial.begin(ESP8266_BAUD);
    delay(10);

    Blynk.begin(BLYNK_AUTH_TOKEN, wifi, ssid, pass);
    timer.setInterval(500L, sendSoundLevel); // Send the sound level once every 500ms

    Blynk.virtualWrite(V1, 0);
}

void sendSoundLevel() {
    float soundValue = CircuitPlayground.mic.soundPressureLevel(100); // Take 100ms of sound
    if (soundValue > SOUND_THRESHOLD_ON && !isTVOn) {
        Blynk.virtualWrite(V1, 1); // Let the good roommate know the tv was turned on
        isTVOn = 1;
    } else if (isTVOn && soundValue < SOUND_THRESHOLD_OFF) {
        isTVOn = 0;
        Blynk.virtualWrite(V1, 0); // Let the good roommate know the tv was turned off
    }
}

void loop() {
    Blynk.run();
    timer.run();
}

BLYNK_WRITE(V0) {
    int value = param.asInt();
    if (value) {
        CircuitPlayground.irSend.send(MY_PROTOCOL,MY_POWER,MY_BITS); // Turn off the tv
        Blynk.virtualWrite(V0, 0); // Turn off the blynk app button
    }
}
